#define MAX_CONNECTIONS	128
#define MAX_ENTRIES	20
#define VERSION		001
#define MAX_EXCLUDED	100

struct statistics {
	unsigned short		active_transfers;
	double			total_bytes_transfered;
	double			bytes_left;
	double			transfer_time;
};

struct	tb_update {
	unsigned char	command;
	double		value;
};

struct entry_list {
	int			port;
	char			*host;
	unsigned long		pass;
};


struct entry_container {
	unsigned char	bnc_status;
	unsigned short	bnc_connections;
	unsigned long	bnc_bytes;
	unsigned long	bnc_bytes_left;
	unsigned long	bnc_reset;
	char		bnc_ip[16];
	long		bnc_speed;
	int		bnc_fd;

	unsigned long	bnc_reply;
	unsigned char	user_online;
	unsigned char	storage;
};


struct conn {
        int		owner;
	unsigned char	entry;
        int		source_socket;
        int		listen_socket;
};
  

struct cmd_t {
	char		cmd;
	int             owner;
	char		hostname[ 16 ];
	int		port;

	unsigned char	target;
};

struct cmd {
	char		cmd;
	int             owner;
	char		hostname[ 16 ];
	int		port;
};

  
struct rsp {
	int		owner;
	unsigned long	value;
};


#define		REQ_AUTH		0
#define		REQ_PORT		1
#define		REQ_PASV		5
#define		REQ_ACCEPT		2
#define		REQ_CLEAR		3
#define		REQ_STATS		4

#define		NOONE			-1

#define		OFFLINE			0
#define		ACTIVE			1
#define		CLOSED			2
#define		WAIT_AUTH		3

#define         OTHER                   0
#define         PASV                    1
#define         TRANSFER                2

#define         OK                      0
#define         FAIL                    1
#define         NULLSTR                 ""
 
#define		OFF			0
#define		ON			1

#define		STATS_BYTES		-1
#define		STATS_CONNECTIONS	-2
#define		STATS_SPEED		-3
#define		PASSKEY			-4
#define		STATS_RESET		-5
#define		STATS_BYTES_LEFT	-6
#define		PONG			-7

#define		SET_EXCLUDED		0
#define		SET_LEFT		1
#define		SET_TOTAL		2
#define		SET_TIME		3
#define		SET_TRANSFERS		4
#define		UPDATE_ALL		5


#ifdef TLS
#include "tlsutil.h"
#define READ     tls_read
#define WRITE    tls_write
#define SEND     tls_send
#define FGETC    tls_fgetc
#define FPUTS    tls_fputs
#define PUTC     tls_fputc
#define FFLUSH   tls_fflush
#define CLOSE    tls_close
#define FCLOSE   tls_fclose
#define VFPRINTF tls_vfprintf
#define FPRINTF  tls_fprintf
#else
#define READ     read
#define WRITE    write
#define SEND     send
#define FGETC    fgetc
#define FPUTS    fputs
#define FFLUSH   fflush
#define PUTC     putc
#define CLOSE    close
#define FCLOSE   fclose
#define VFPRINTF vfprintf
#define FPRINTF  fprintf
#endif
