#include <stdio.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <stdlib.h>
#include <unistd.h>
#include <openssl/blowfish.h>




int main(int argc, char **argv) {
 struct stat	f_stat;
 BF_KEY		bf_key;
 char		config_key[256];
 char		t_str[10];
 int		config_key_len = 0;
 char		ivec[8];
 char		*buf;
 char		*src, *dst;
 int		fd1, fd2;
 int		ipos = 0;
 int		mode;

 switch ( argc ) {
	case 3:
		src = argv[1];
		dst = argv[2];
		mode = BF_ENCRYPT;
		break;
	case 4:
		if ( ! strcmp(argv[1], "-d")) {
			src = argv[2];
			dst = argv[3];
			mode = BF_DECRYPT;
			break;
			}
	default:
		printf("Usage: %s [-d] <source> <target>\n", argv[0]);
		printf("\n");
		printf("   -d   decrypt (default encrypt)\n");
		printf("\n");
		exit(0);
		break;
	}

 printf("Password: ");
 sprintf(t_str, "%%%us", sizeof(config_key));
 scanf(t_str, config_key);
 config_key_len = strlen(config_key);

 if ((fd1 = open(src, O_RDONLY)) < 0 || fstat(fd1, &f_stat) == -1) {
	printf("ERROR: Could not open %s\n", src);
	exit(2);
	}

 buf = malloc(f_stat.st_size);
 read(fd1, buf, f_stat.st_size);

 bzero(ivec, sizeof(ivec));
 BF_set_key(&bf_key, config_key_len, config_key);
 BF_cfb64_encrypt((void *)buf, (void *)buf, f_stat.st_size, &bf_key, ivec, &ipos, mode);

 if ((fd2 = open(dst, O_CREAT|O_TRUNC|O_WRONLY, 0600)) < 0) {
	printf("ERROR: Could not create %s\n", dst);
	}
 write(fd2, buf, f_stat.st_size);
 close(fd2);
 close(fd1);
 printf("File created: %s (%u bytes)\n", dst, f_stat.st_size);
}
